伍佰目录 短网址
  当前位置:海洋目录网 » 站长资讯 » 站长资讯 » 文章详细 订阅RssFeed

Netdata 新一代实时监控系统(2)

来源:本站原创 浏览:64次 时间:2023-01-19
2. Linux在线安装Netdata Agent,并接入Netdata Cloud

Netdata agent用于采集监控指标,可以在本地存储和通过浏览器展示,Netdata Cloud 可以收集多个agent的流式数据集中展示监控图标。

2.1 注意事项
  • 安全前使用下面的命令更新操作系统

    yum update
  • agent安装不需要 sudo
  • 脚本自动安装依赖,自动从源码编译
  • agent可以从prometheus采集数据,包括windows 10
  • 由于各种原因,在线安装可能非常缓慢甚至失败
  • 建议参考下面的链接,离线安装

    https://blog.51cto.com/wuweijava/2580398

  • cloud从agent接受流式数据,在浏览器中显示,但不保存数据
2.2 使用kickstart脚本在线安装

bash <(curl -Ss https://my-netdata.io/kickstart.sh) --no-updates --stable-channel --disable-telemetry

  • --no-updates

    不启用自动更新,若不指定该参数,默认启用自动更新

  • --stable-channel

    指定安装稳定版,若不指定该参数,默认安装最新版

  • --disable-telemetry

    禁止发送匿名统计信息,若不指定该参数,默认允许发送

下面是脚本内容

#!/usr/bin/env sh# SPDX-License-Identifier: GPL-3.0-or-later## Run me with:## bash <(curl -Ss https://my-netdata.io/kickstart.sh)## or (to install all netdata dependencies):## bash <(curl -Ss https://my-netdata.io/kickstart.sh) all## Other options:#  --dont-wait                do not prompt for user input#  --non-interactive          do not prompt for user input#  --no-updates               do not install script for daily updates#  --local-files              set the full path of the desired tarball to run install with#  --allow-duplicate-install  do not bail if we detect a duplicate install#  --reinstall                if an existing install would be updated, reinstall instead## Environment options:##  TMPDIR                     specify where to save temporary files#  NETDATA_TARBALL_BASEURL    set the base url for downloading the dist tarball## This script will:## 1. install all netdata compilation dependencies#    using the package manager of the system## 2. download netdata nightly package to temporary directory## 3. install netdata# shellcheck disable=SC2039,SC2059,SC2086# External filesPACKAGES_SCRIPT="https://raw.githubusercontent.com/netdata/netdata/master/packaging/installer/install-required-packages.sh"# Netdata Tarball Base URL (defaults to our Google Storage Bucket)[ -z "$NETDATA_TARBALL_BASEURL" ] && NETDATA_TARBALL_BASEURL=https://storage.googleapis.com/netdata-nightlies# ---------------------------------------------------------------------------------------------------------------------# library functions copied from packaging/installer/functions.shsetup_terminal() {  TPUT_RESET=""  TPUT_YELLOW=""  TPUT_WHITE=""  TPUT_BGRED=""  TPUT_BGGREEN=""  TPUT_BOLD=""  TPUT_DIM=""  # Is stderr on the terminal? If not, then fail  test -t 2 || return 1  if command -v tput > /dev/null 2>&1; then    if [ $(($(tput colors 2> /dev/null))) -ge 8 ]; then      # Enable colors      TPUT_RESET="$(tput sgr 0)"      TPUT_YELLOW="$(tput setaf 3)"      TPUT_WHITE="$(tput setaf 7)"      TPUT_BGRED="$(tput setab 1)"      TPUT_BGGREEN="$(tput setab 2)"      TPUT_BOLD="$(tput bold)"      TPUT_DIM="$(tput dim)"    fi  fi  return 0}setup_terminal || echo > /dev/null# -----------------------------------------------------------------------------fatal() {  printf >&2 "${TPUT_BGRED}${TPUT_WHITE}${TPUT_BOLD} ABORTED ${TPUT_RESET} ${*} \n\n"  exit 1}run_ok() {  printf >&2 "${TPUT_BGGREEN}${TPUT_WHITE}${TPUT_BOLD} OK ${TPUT_RESET} \n\n"}run_failed() {  printf >&2 "${TPUT_BGRED}${TPUT_WHITE}${TPUT_BOLD} FAILED ${TPUT_RESET} \n\n"}ESCAPED_PRINT_METHOD=if printf "%q " test > /dev/null 2>&1; then  ESCAPED_PRINT_METHOD="printfq"fiescaped_print() {  if [ "${ESCAPED_PRINT_METHOD}" = "printfq" ]; then    printf "%q " "${@}"  else    printf "%s" "${*}"  fi  return 0}progress() {  echo >&2 " --- ${TPUT_DIM}${TPUT_BOLD}${*}${TPUT_RESET} --- "}run_logfile="/dev/null"run() {  local user="${USER--}" dir="${PWD}" info info_console  if [ "${UID}" = "0" ]; then    info="[root ${dir}]# "    info_console="[${TPUT_DIM}${dir}${TPUT_RESET}]# "  else    info="[${user} ${dir}]$ "    info_console="[${TPUT_DIM}${dir}${TPUT_RESET}]$ "  fi  {    printf "${info}"    escaped_print "${@}"    printf " ... "  } >> "${run_logfile}"  printf >&2 "${info_console}${TPUT_BOLD}${TPUT_YELLOW}"  escaped_print >&2 "${@}"  printf >&2 "${TPUT_RESET}"  "${@}"  local ret=$?  if [ ${ret} -ne 0 ]; then    run_failed    printf >> "${run_logfile}" "FAILED with exit code ${ret}\n"  else    run_ok    printf >> "${run_logfile}" "OK\n"  fi  return ${ret}}fatal() {  printf >&2 "${TPUT_BGRED}${TPUT_WHITE}${TPUT_BOLD} ABORTED ${TPUT_RESET} ${*} \n\n"  exit 1}warning() {  printf >&2 "${TPUT_BGRED}${TPUT_WHITE}${TPUT_BOLD} WARNING ${TPUT_RESET} ${*} \n\n"  if [ "${INTERACTIVE}" = "0" ]; then    fatal "Stopping due to non-interactive mode. Fix the issue or retry installation in an interactive mode."  else    read -r -p "Press ENTER to attempt netdata installation > "    progress "OK, let's give it a try..."  fi}_cannot_use_tmpdir() {  local testfile ret  testfile="$(TMPDIR="${1}" mktemp -q -t netdata-test.XXXXXXXXXX)"  ret=0  if [ -z "${testfile}" ] ; then    return "${ret}"  fi  if printf '#!/bin/sh\necho SUCCESS\n' > "${testfile}" ; then    if chmod +x "${testfile}" ; then      if [ "$("${testfile}")" = "SUCCESS" ] ; then        ret=1      fi    fi  fi  rm -f "${testfile}"  return "${ret}"}create_tmp_directory() {  if [ -z "${TMPDIR}" ] || _cannot_use_tmpdir "${TMPDIR}" ; then    if _cannot_use_tmpdir /tmp ; then      if _cannot_use_tmpdir "${PWD}" ; then        echo >&2        echo >&2 "Unable to find a usable temprorary directory. Please set \$TMPDIR to a path that is both writable and allows execution of files and try again."        exit 1      else        TMPDIR="${PWD}"      fi    else      TMPDIR="/tmp"    fi  fi  mktemp -d -t netdata-kickstart-XXXXXXXXXX}download() {  url="${1}"  dest="${2}"  if command -v curl > /dev/null 2>&1; then    run curl -q -sSL --connect-timeout 10 --retry 3 --output "${dest}" "${url}"  elif command -v wget > /dev/null 2>&1; then    run wget -T 15 -O "${dest}" "${url}" || fatal "Cannot download ${url}"  else    fatal "I need curl or wget to proceed, but neither is available on this system."  fi}set_tarball_urls() {  if [ -n "${NETDATA_LOCAL_TARBALL_OVERRIDE}" ]; then    progress "Not fetching remote tarballs, local override was given"    return  fi  if [ "$1" = "stable" ]; then    local latest    # Simple version    latest="$(download "https://api.github.com/repos/netdata/netdata/releases/latest" /dev/stdout | grep tag_name | cut -d'"' -f4)"    export NETDATA_TARBALL_URL="https://github.com/netdata/netdata/releases/download/$latest/netdata-$latest.tar.gz"    export NETDATA_TARBALL_CHECKSUM_URL="https://github.com/netdata/netdata/releases/download/$latest/sha256sums.txt"  else    export NETDATA_TARBALL_URL="$NETDATA_TARBALL_BASEURL/netdata-latest.tar.gz"    export NETDATA_TARBALL_CHECKSUM_URL="$NETDATA_TARBALL_BASEURL/sha256sums.txt"  fi}detect_bash4() {  bash="${1}"  if [ -z "${BASH_VERSION}" ]; then    # we don't run under bash    if [ -n "${bash}" ] && [ -x "${bash}" ]; then      # shellcheck disable=SC2016      BASH_MAJOR_VERSION=$(${bash} -c 'echo "${BASH_VERSINFO[0]}"')    fi  else    # we run under bash    BASH_MAJOR_VERSION="${BASH_VERSINFO[0]}"  fi  if [ -z "${BASH_MAJOR_VERSION}" ]; then    echo >&2 "No BASH is available on this system"    return 1  elif [ $((BASH_MAJOR_VERSION)) -lt 4 ]; then    echo >&2 "No BASH v4+ is available on this system (installed bash is v${BASH_MAJOR_VERSION}"    return 1  fi  return 0}dependencies() {  SYSTEM="$(uname -s 2> /dev/null || uname -v)"  OS="$(uname -o 2> /dev/null || uname -rs)"  MACHINE="$(uname -m 2> /dev/null)"  echo "System            : ${SYSTEM}"  echo "Operating System  : ${OS}"  echo "Machine           : ${MACHINE}"  echo "BASH major version: ${BASH_MAJOR_VERSION}"  if [ "${OS}" != "GNU/Linux" ] && [ "${SYSTEM}" != "Linux" ]; then    warning "Cannot detect the packages to be installed on a ${SYSTEM} - ${OS} system."  else    bash="$(command -v bash 2> /dev/null)"    if ! detect_bash4 "${bash}"; then      warning "Cannot detect packages to be installed in this system, without BASH v4+."    else      progress "Fetching script to detect required packages..."      if [ -n "${NETDATA_LOCAL_TARBALL_OVERRIDE_DEPS_SCRIPT}" ]; then        if [ -f "${NETDATA_LOCAL_TARBALL_OVERRIDE_DEPS_SCRIPT}" ]; then          run cp "${NETDATA_LOCAL_TARBALL_OVERRIDE_DEPS_SCRIPT}" "${ndtmpdir}/install-required-packages.sh"        else          fatal "Invalid given dependency file, please check your --local-files parameter options and try again"        fi      else        download "${PACKAGES_SCRIPT}" "${ndtmpdir}/install-required-packages.sh"      fi      if [ ! -s "${ndtmpdir}/install-required-packages.sh" ]; then        warning "Downloaded dependency installation script is empty."      else        progress "Running downloaded script to detect required packages..."        run ${sudo} "${bash}" "${ndtmpdir}/install-required-packages.sh" ${PACKAGES_INSTALLER_OPTIONS}        # shellcheck disable=SC2181        if [ $? -ne 0 ]; then          warning "It failed to install all the required packages, but installation might still be possible."        fi      fi    fi  fi}safe_sha256sum() {  # Within the contexct of the installer, we only use -c option that is common between the two commands  # We will have to reconsider if we start non-common options  if command -v sha256sum > /dev/null 2>&1; then    sha256sum "$@"  elif command -v shasum > /dev/null 2>&1; then    shasum -a 256 "$@"  else    fatal "I could not find a suitable checksum binary to use"  fi}# ---------------------------------------------------------------------------------------------------------------------umask 022sudo=""[ -z "${UID}" ] && UID="$(id -u)"[ "${UID}" -ne "0" ] && sudo="sudo"export PATH="${PATH}:/usr/local/bin:/usr/local/sbin"# ---------------------------------------------------------------------------------------------------------------------INTERACTIVE=1PACKAGES_INSTALLER_OPTIONS="netdata"NETDATA_INSTALLER_OPTIONS=""NETDATA_UPDATES="--auto-update"RELEASE_CHANNEL="nightly"while [ -n "${1}" ]; do  if [ "${1}" = "all" ]; then    PACKAGES_INSTALLER_OPTIONS="netdata-all"    shift 1  elif [ "${1}" = "--dont-wait" ] || [ "${1}" = "--non-interactive" ]; then    INTERACTIVE=0    shift 1  elif [ "${1}" = "--no-updates" ]; then    # echo >&2 "netdata will not auto-update"    NETDATA_UPDATES=    shift 1  elif [ "${1}" = "--stable-channel" ]; then    RELEASE_CHANNEL="stable"    NETDATA_INSTALLER_OPTIONS="$NETDATA_INSTALLER_OPTIONS --stable-channel"    shift 1  elif [ "${1}" = "--allow-duplicate-install" ]; then    NETDATA_ALLOW_DUPLICATE_INSTALL=1    shift 1  elif [ "${1}" = "--reinstall" ]; then    NETDATA_REINSTALL=1    shift 1  elif [ "${1}" = "--local-files" ]; then    shift 1    if [ -z "${1}" ]; then      fatal "Missing netdata: Option --local-files requires extra information. The desired tarball for netdata, the checksum, the go.d plugin tarball , the go.d plugin config tarball and the dependency management script, in this particular order"    fi    export NETDATA_LOCAL_TARBALL_OVERRIDE="${1}"    shift 1    if [ -z "${1}" ]; then      fatal "Missing checksum file: Option --local-files requires extra information. The desired tarball for netdata, the checksum, the go.d plugin tarball , the go.d plugin config tarball and the dependency management script, in this particular order"    fi    export NETDATA_LOCAL_TARBALL_OVERRIDE_CHECKSUM="${1}"    shift 1    if [ -z "${1}" ]; then      fatal "Missing go.d tarball: Option --local-files requires extra information. The desired tarball for netdata, the checksum, the go.d plugin tarball , the go.d plugin config tarball and the dependency management script, in this particular order"    fi    export NETDATA_LOCAL_TARBALL_OVERRIDE_GO_PLUGIN="${1}"    shift 1    if [ -z "${1}" ]; then      fatal "Missing go.d config tarball: Option --local-files requires extra information. The desired tarball for netdata, the checksum, the go.d plugin tarball , the go.d plugin config tarball and the dependency management script, in this particular order"    fi    export NETDATA_LOCAL_TARBALL_OVERRIDE_GO_PLUGIN_CONFIG="${1}"    shift 1    if [ -z "${1}" ]; then      fatal "Missing dependencies management scriptlet: Option --local-files requires extra information. The desired tarball for netdata, the checksum, the go.d plugin tarball , the go.d plugin config tarball and the dependency management script, in this particular order"    fi    export NETDATA_LOCAL_TARBALL_OVERRIDE_DEPS_SCRIPT="${1}"    shift 1  else    NETDATA_INSTALLER_OPTIONS="$NETDATA_INSTALLER_OPTIONS ${1}"    shift 1  fidoneif [ "${INTERACTIVE}" = "0" ]; then  PACKAGES_INSTALLER_OPTIONS="--dont-wait --non-interactive ${PACKAGES_INSTALLER_OPTIONS}"  NETDATA_INSTALLER_OPTIONS="$NETDATA_INSTALLER_OPTIONS --dont-wait"fi# ---------------------------------------------------------------------------------------------------------------------# look for an existing install and try to update that instead if it existsndpath="$(command -v netdata 2>/dev/null)"if [ -z "$ndpath" ] && [ -x /opt/netdata/bin/netdata ] ; then    ndpath="/opt/netdata/bin/netdata"fiif [ -n "$ndpath" ] ; then  ndprefix="$(dirname "$(dirname "${ndpath}")")"  if [ "${ndprefix}" = /usr ] ; then    ndprefix="/"  fi  progress "Found existing install of Netdata under: ${ndprefix}"  if [ -r "${ndprefix}/etc/netdata/.environment" ] ; then    ndstatic="$(grep IS_NETDATA_STATIC_BINARY "${ndprefix}/etc/netdata/.environment" | cut -d "=" -f 2 | tr -d \")"    if [ -z "${NETDATA_REINSTALL}" ] && [ -z "${NETDATA_LOCAL_TARBALL_OVERRIDE}" ] ; then      if [ -x "${ndprefix}/usr/libexec/netdata/netdata-updater.sh" ] ; then        progress "Attempting to update existing install instead of creating a new one"        if run ${sudo} "${ndprefix}/usr/libexec/netdata/netdata-updater.sh" --not-running-from-cron ; then          progress "Updated existing install at ${ndpath}"          exit 0        else          fatal "Failed to update existing Netdata install"          exit 1        fi      else        if [ -z "${NETDATA_ALLOW_DUPLICATE_INSTALL}" ] || [ "${ndstatic}" = "yes" ] ; then          fatal "Existing installation detected which cannot be safely updated by this script, refusing to continue."          exit 1        else          progress "User explicitly requested duplicate install, proceeding."        fi      fi    else      if [ "${ndstatic}" = "no" ] ; then        progress "User requested reinstall instead of update, proceeding."      else        fatal "Existing install is a static install, please use kickstart-static64.sh instead."        exit 1      fi    fi  else    progress "Existing install appears to be handled manually or through the system package manager."    if [ -z "${NETDATA_ALLOW_DUPLICATE_INSTALL}" ] ; then      fatal "Existing installation detected which cannot be safely updated by this script, refusing to continue."      exit 1    else      progress "User explicitly requested duplicate install, proceeding."    fi  fifi# ---------------------------------------------------------------------------------------------------------------------# install required system packagesndtmpdir=$(create_tmp_directory)cd "${ndtmpdir}" || exit 1dependencies# ---------------------------------------------------------------------------------------------------------------------# download netdata packageif [ -z "${NETDATA_LOCAL_TARBALL_OVERRIDE}" ]; then  set_tarball_urls "${RELEASE_CHANNEL}"  download "${NETDATA_TARBALL_CHECKSUM_URL}" "${ndtmpdir}/sha256sum.txt"  download "${NETDATA_TARBALL_URL}" "${ndtmpdir}/netdata-latest.tar.gz"else  progress "Installation sources were given as input, running installation using \"${NETDATA_LOCAL_TARBALL_OVERRIDE}\""  run cp "${NETDATA_LOCAL_TARBALL_OVERRIDE_CHECKSUM}" "${ndtmpdir}/sha256sum.txt"  run cp "${NETDATA_LOCAL_TARBALL_OVERRIDE}" "${ndtmpdir}/netdata-latest.tar.gz"fiif ! grep netdata-latest.tar.gz "${ndtmpdir}/sha256sum.txt" | safe_sha256sum -c - > /dev/null 2>&1; then  fatal "Tarball checksum validation failed. Stopping Netdata Agent installation and leaving tarball in ${ndtmpdir}.\nUsually this is a result of an older copy of the file being cached somewhere upstream and can be resolved by retrying in an hour."firun tar -xf netdata-latest.tar.gzrm -rf netdata-latest.tar.gz > /dev/null 2>&1cd netdata-* || fatal "Cannot cd to netdata source tree"# ---------------------------------------------------------------------------------------------------------------------# install netdata from sourceinstall() {  progress "Installing netdata..."  run ${sudo} ./netdata-installer.sh ${NETDATA_UPDATES} ${NETDATA_INSTALLER_OPTIONS} || fatal "netdata-installer.sh exited with error"  if [ -d "${ndtmpdir}" ] && [ ! "${ndtmpdir}" = "/" ]; then    run ${sudo} rm -rf "${ndtmpdir}" > /dev/null 2>&1  fi}if [ -x netdata-installer.sh ]; then  install "$@"else  if [ "$(find . -mindepth 1 -maxdepth 1 -type d | wc -l)" -eq 1 ] && [ -x "$(find . -mindepth 1 -maxdepth 1 -type d)/netdata-installer.sh" ]; then    cd "$(find . -mindepth 1 -maxdepth 1 -type d)" && install "$@"  else    fatal "Cannot install netdata from source (the source directory does not include netdata-installer.sh). Leaving all files in ${ndtmpdir}"  fifi
2.3 启用内存重复数据删除KMS

运行下面的命令

echo 1 >/sys/kernel/mm/ksm/runecho 1000 >/sys/kernel/mm/ksm/sleep_millisecs

启用该功能可以减少netdata 40% ~ 60% 的内存占用

2.4 默认的监听端口

netdata默认会监听主机所有IP的19999端口,浏览器通过下面的地址访问

http://this.machine.ip:19999/

2.5 启动与关闭

启动netdata

systemctl start netdata

关闭netdata
systemctl stop netdata

2.6 更新与卸载

更新脚本
/usr/libexec/netdata/netdata-updater.sh
卸载脚本
/usr/libexec/netdata/netdata-uninstaller.sh

2.7 接入Netdata Cloud1. 在netdata官网注册账号并登陆

2. 创建工作空间

3. 创建作战室

4. 获取主机加入cloud的命令

5. 进入工作空间

6. 主机运行加入cloud的命令
sudo netdata-claim.sh -token=smN1DaYQPEloPnOGqOYdn7QWIoYfJJt3ZAV8mP41W5IRrJS_2b5kwffEKKGdO6PRavXOYgUDJ_Zs8I1VoLJEDzvzFT13NPMLl_9VzcE -rooms=9b856134-4f16-4444-8768-5b896ae98725 -url=https://app.netdata.cloud

注意每个cloud用户的token和rooms都不相同,请妥善保管

7. 登录cloud查看

  推荐站点

  • At-lib分类目录At-lib分类目录

    At-lib网站分类目录汇集全国所有高质量网站,是中国权威的中文网站分类目录,给站长提供免费网址目录提交收录和推荐最新最全的优秀网站大全是名站导航之家

    www.at-lib.cn
  • 中国链接目录中国链接目录

    中国链接目录简称链接目录,是收录优秀网站和淘宝网店的网站分类目录,为您提供优质的网址导航服务,也是网店进行收录推广,站长免费推广网站、加快百度收录、增加友情链接和网站外链的平台。

    www.cnlink.org
  • 35目录网35目录网

    35目录免费收录各类优秀网站,全力打造互动式网站目录,提供网站分类目录检索,关键字搜索功能。欢迎您向35目录推荐、提交优秀网站。

    www.35mulu.com
  • 就要爱网站目录就要爱网站目录

    就要爱网站目录,按主题和类别列出网站。所有提交的网站都经过人工审查,确保质量和无垃圾邮件的结果。

    www.912219.com
  • 伍佰目录伍佰目录

    伍佰网站目录免费收录各类优秀网站,全力打造互动式网站目录,提供网站分类目录检索,关键字搜索功能。欢迎您向伍佰目录推荐、提交优秀网站。

    www.wbwb.net